export interface Serializer {
   /**
       *
       * @param buffer Buffer to write to (should be capable to hold this.length)
       * @param offset The offset at wich to start writing
       * @returns The new offset (should be equal to original offset + this.length)
       */
   serialize(buffer: Buffer, offset: number): number;

   /**
    * Returns length of serialized data
    * @readonly
    */
   length: number;
}

export interface Serializeable {
   lock(): Serializer;
}